﻿##!/usr/bin/env python

#import gtk

class pluginExportText:

    def __init__(self,info,dico):
        '''Dico est le protolist de l'arbre des calculs'''

        import gtk

        wParent = None
        wFileSelection = gtk.FileChooserDialog("Exporter dans un fichier texte brute ...",
                                               wParent,
                                               gtk.FILE_CHOOSER_ACTION_SAVE,
                                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                               gtk.STOCK_OK, gtk.RESPONSE_OK));
        #filter = gtk.FileFilter()
        #filter.set_name('toto')
        ##filter.add_pattern(format)
        #wFileSelection.add_filter(filter)



        if (wFileSelection.run() == gtk.RESPONSE_OK):
            print ('nom du fichier : %s'%wFileSelection.get_filename())
            self.createTXT(wFileSelection.get_filename(),info,dico)
            wFileSelection.destroy()
        else:
            wFileSelection.destroy()






        # Arret de la boucle evenementielle
        #gtk.main_quit()


    def createTXT(self,filename,info,list):
        from time import strftime
        file = open(filename,'w')
        file.write("+-------------------------------------------------------------------------\n")
        file.write("| %s\n"%info['title'])
        file.write("+-------------------------------------------------------------------------\n")
        file.write("Auteur : %s - créé le %s - imprimé le %s\n\n"%(info['author'],info['date'],strftime('%d/%m/%Y %H:%m')))
        file.write("%s\n\n\n"%info['description'])

        for item in list:
            if item['type'] == 'img' :
                '''entrée de type image'''
                file.write("%s) Figure : %s"%(item['id'],item['render']))
            elif item['resultat'] != None :
                '''contient un resultat'''
                if item['unit'] != '' :
                    '''unitiée précisée'''
                    file.write("%s) %s = %s [%s]\n\n"%(item['id'],item['render'],item['resultat'],item['unit']))
                else :
                    '''unitiée non précisée'''
                    file.write("%s) %s = %s\n\n"%(item['id'],item['render'],item['resultat']))
            else :
                file.write("%s) %s\n\n"%(item['id'],item['render']))

        file.close()

        return True


# Fonction oblicatoir pour tout les plugins, c'es celle qui est lancer lors
# du click sur ok de la boite de selection des plugins
def run(dicoInfo,dicoCalc):
    pluginExportText(dicoInfo,dicoCalc)
    return True



# Si lancement direct : petits dicos bindons pour test
if __name__ == '__main__':
    '''Pour les tester : dicos bidons'''
    from time import strftime
    dicoInfo = {
        'title': 'Titre',
        'description': 'blabla',
        'author': 'JF',
        'date' : strftime('%d/%m/%Y %H:%M')
        }
    listCalc = [
    #  (ID,  entry, render, aff ,precRes, res,   unit, listVar, comm)
        {'id' :'1',   'entry': '2+2', 'render':'2+2', 'aff': '2', 'precRes':'1', 'res':'5', 'unit':'kN', 'listVar':(1,2), 'comm':'blabla'}
        ]
    run(dicoInfo,listCalc)
    gtk.main()
