#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Auteur :  Jonas Fourquier (http://jonas.tuxfamily.org)
# Licence : GNU GPL
# Version : 0

import os
import const #constant notecalc
import ncalc_cst
from random import choice
import pdb
#pdb.set_trace()

def unlinkrecursif(path) :
    '''Fonction de suppression récursive'''
    if os.path.exists(path) :
        for file in os.listdir(path) :
            file = os.path.join(path,file)
            if os.path.isfile(file) :
                os.unlink(file)
            else :
                unlinkrecursif(file)
        os.rmdir(path)
    else :
        print "%s n'existe pas"%path

#Definition de variable d'environnement et Creation (si il n'existe pas) des dossiers de travail de noteCalc
try :
    os.environ['NOTECALC_DIR'] = os.path.dirname(os.path.realpath(__file__))
except :
    os.environ['NOTECALC_DIR'] = os.getcwd()
#~ print __file__
#~ print os.path.dirname(__file__)
#~ print os.getcwd()
from shutil import copy


if 'HOME' in os.environ :
    os.environ['NOTECALC_USERDIR'] = os.path.join(os.environ['HOME'],'.notecalc')
elif ('HOMEPATH' in os.environ) & ('HOMEDRIVE' in os.environ):
    os.environ['NOTECALC_USERDIR'] = os.path.join(os.environ['HOMEDRIVE'],os.environ['HOMEPATH'],'.notecalc')
else :
    print 'Erreur dans notecalc.py ! Aucune variable d\'environnement de dossier utilisateur détectée merci de contacter l\'auteur de notecalc'
    exit()
#~ os.path.expanduser("~")

if 'USER' not in os.environ :
    os.environ['USER'] = os.environ['USERNAME']

# Config des plugins
os.environ['NOTECALC_CONFPLUGINSDIR'] = os.path.join(os.environ['NOTECALC_USERDIR'],'conf_plugins')
#dossier temporaire
os.environ['NOTECALC_TMP'] = os.path.join(os.environ['NOTECALC_USERDIR'],'tmp')

#crétion du dossier utilisateur
try :
    os.mkdir(os.environ['NOTECALC_USERDIR'])
except :
    pass

try :
    os.mkdir(os.environ['NOTECALC_CONFPLUGINSDIR'])
except :
    pass

try :
    os.mkdir(os.environ['NOTECALC_TMP'])
except :
    pass

if not os.path.exists(os.path.join(os.environ['NOTECALC_USERDIR'],'edit_image.ini')) :
    if os.name=='nt' :
        copy(
                os.path.join(os.environ['NOTECALC_DIR'],'edit_image_nt.ini'),
                os.path.join(os.environ['NOTECALC_USERDIR'],'edit_image.ini')
            )
    else :
        copy(
                os.path.join(os.environ['NOTECALC_DIR'],'edit_image.ini'),
                os.path.join(os.environ['NOTECALC_USERDIR'],'edit_image.ini')
            )

if not os.path.exists(os.path.join(os.environ['NOTECALC_USERDIR'],'astuces.ini')) :
    copy(
            os.path.join(os.environ['NOTECALC_DIR'],'astuces.ini'),
            os.path.join(os.environ['NOTECALC_USERDIR'],'astuces.ini')
        )

tmp_dir = []
currentdir = os.environ['NOTECALC_USERDIR']
while (os.path.exists(currentdir)):
    for i in range(10):
        tmp_dir.append(choice('1234567890abcdefghijklmnopqrst'))
    currentdir = os.path.join(os.environ['NOTECALC_USERDIR'],''.join(tmp_dir))

    tmp_dir = []

#~ global currentdirfile


os.mkdir(currentdir)
os.chdir(currentdir)
print "dossier de travail : %s"%os.getcwd()
os.mkdir('pictures')
ncalc_cst.set_currentdir(currentdir)

os.chdir(os.environ['NOTECALC_USERDIR'])

import gui      # Interface graphique

print "Suppression du dossier temporaire"
unlinkrecursif(os.path.join(os.environ['NOTECALC_USERDIR'],'tmp'))
#~ except :
    #~ print 'une erreur est survennu (impossible de supprimer le dossier ou un des fichiers qu\'il contient'

print "Suppression du dossier de travail "
unlinkrecursif(os.path.join(os.environ['NOTECALC_USERDIR'], ncalc_cst.get_currentdir()))

